const readlineSync = require('readline-sync');
var ConInterface = exports;

ConInterface.getConsoleGridInterfaceInput = function (horizontalBorder, verticalBorder, spacer, marker, startX, startY, borderWidth, borderHeight, showCoords, showIntructions, deleteOnCompletion) {
	var x = startX, y = startY, width = borderWidth, height = borderHeight;

	if(showIntructions){
		console.log('    ^');
		console.log('    W');
		console.log('< A   D >	[SPACE] Accept Co-ordinates');
		console.log('    S');
		console.log('    v');
	}
	console.log(new Array(width + 4).join(horizontalBorder));
	for(var i = 0; i <= height; i++){
		if(i == y){
			console.log(verticalBorder + new Array(x + 1).join(spacer) + marker + 
						new Array(width - x + 1).join(spacer) + verticalBorder);
		}else{
			console.log(verticalBorder + new Array(x + 1).join(spacer) + spacer +
						new Array(width - x + 1).join(spacer) + verticalBorder);
		}
	}
	console.log(new Array(width + 4).join(horizontalBorder));
	if(showCoords){
		console.log('X: '+x);
		console.log('Y: '+y);
	}

	// listen for the "keypress" event 
	while (true) {
		key = readlineSync.keyIn('', {
			hideEchoBack: true, 
			mask: '', 
			limit: 'wasd '
		});
		//console.log('got "keypress"', key);
		if (key && key.ctrl && key.name == 'c') {
			process.stdin.pause();
		}

		if(key == 'a')
			x--;

		if(key == 'd')
			x++;

		if(key == 'w')
			y--;

		if(key == 's')
			y++;

		if(key == ' ')
			break;

		if(x < 0)
			x = 0;

		if(x > width)
			x = width;

		if(y < 0)
			y = 0;

		if(y > height)
			y = height;

		if(showIntructions && showCoords){
			console.log('\x1B['+(borderHeight+10)+'A    ^\x1B[K');
			console.log('    W\x1B[K');
			console.log('< A   D >	[SPACE] Accept Co-ordinates\x1B[K');
			console.log('    S\x1B[K');
			console.log('    v\x1B[K');
			console.log(new Array(width + 4).join(horizontalBorder)+'\x1B[K');
			for(var i = 0; i <= height; i++){
				if(i == y){
					console.log(verticalBorder + (new Array(x + 1)).join(spacer) + marker +
								(new Array(width - x + 1)).join(spacer) + verticalBorder + '\x1B[K');
				}else{
					console.log(verticalBorder + (new Array(x + 1)).join(spacer) + spacer +
								(new Array(width - x + 1)).join(spacer) + verticalBorder + '\x1B[K');
				}
			}
			console.log(new Array(width + 4).join(horizontalBorder) + '\x1B[K');
			console.log('X: '+x + '\x1B[K');
			console.log('Y: '+y + '\x1B[K');
		}else if(showIntructions && showCoords == false){
			console.log('\x1B['+(borderHeight+8)+'A    ^\x1B[K');
			console.log('    W\x1B[K');
			console.log('< A   D >	[SPACE] Accept Co-ordinates\x1B[K');
			console.log('    S\x1B[K');
			console.log('    v\x1B[K');
			console.log(new Array(width + 4).join(horizontalBorder)+'\x1B[K');
			for(var i = 0; i <= height; i++){
				if(i == y){
					console.log(verticalBorder + (new Array(x + 1)).join(spacer) + marker +
								(new Array(width - x + 1)).join(spacer) + verticalBorder + '\x1B[K');
				}else{
					console.log(verticalBorder + (new Array(x + 1)).join(spacer) + spacer +
								(new Array(width - x + 1)).join(spacer) + verticalBorder + '\x1B[K');
				}
			}
			console.log(new Array(width + 4).join(horizontalBorder) + '\x1B[K');
		}else if(showIntructions == false && showCoords){
			console.log('\x1B['+(borderHeight+5)+'A'+new Array(width + 4).join(horizontalBorder)+'\x1B[K');
			for(var i = 0; i <= height; i++){
				if(i == y){
					console.log(verticalBorder + (new Array(x + 1)).join(spacer) + marker +
								(new Array(width - x + 1)).join(spacer) + verticalBorder + '\x1B[K');
				}else{
					console.log(verticalBorder + (new Array(x + 1)).join(spacer) + spacer +
								(new Array(width - x + 1)).join(spacer) + verticalBorder + '\x1B[K');
				}
			}
			console.log(new Array(width + 4).join(horizontalBorder) + '\x1B[K');
			console.log('X: '+x + '\x1B[K');
			console.log('Y: '+y + '\x1B[K');
		}else{
			console.log('\x1B['+(borderHeight+3)+'A'+new Array(width + 4).join(horizontalBorder)+'\x1B[K');
			for(var i = 0; i <= height; i++){
				if(i == y){
					console.log(verticalBorder + (new Array(x + 1)).join(spacer) + marker +
								(new Array(width - x + 1)).join(spacer) + verticalBorder + '\x1B[K');
				}else{
					console.log(verticalBorder + (new Array(x + 1)).join(spacer) + spacer +
								(new Array(width - x + 1)).join(spacer) + verticalBorder + '\x1B[K');
				}
			}
			console.log(new Array(width + 4).join(horizontalBorder) + '\x1B[K');
		}
		

	}

	if(deleteOnCompletion){
		if(showIntructions && showCoords){
			console.log('\x1B['+(borderHeight+10)+'A\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K');
			for(var i = 0; i <= height; i++){
				if(i == y){
					console.log('\x1B[K');
				}else{
					console.log('\x1B[K');
				}
			}
			console.log('\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K');
		}else if(showIntructions && showCoords == false){
			console.log('\x1B['+(borderHeight+8)+'A\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K');
			for(var i = 0; i <= height; i++){
				if(i == y){
					console.log('\x1B[K');
				}else{
					console.log('\x1B[K');
				}
			}
			console.log('\x1B[K');
		}else if(showIntructions == false && showCoords){
			console.log('\x1B['+(borderHeight+5)+'A\x1B[K');
			for(var i = 0; i <= height; i++){
				if(i == y){
					console.log('\x1B[K');
				}else{
					console.log('\x1B[K');
				}
			}
			console.log('\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K');
		}else{
			console.log('\x1B['+(borderHeight+3)+'A\x1B[K');
			for(var i = 0; i <= height; i++){
				if(i == y){
					console.log('\x1B[K');
				}else{
					console.log('\x1B[K');
				}
			}
			console.log('\x1B[K');
		}
	}

	return {x: x, y: y};
}

ConInterface.getConsoleSliderInterfaceInput = function (leftEndChar, rightEndChar, spacer, marker, startValue, sliderWidth, showValue, showIntructions, deleteOnCompletion) {
	var value = startValue, width = sliderWidth;

	if(showIntructions && showValue){
		console.log('< A   D >	[SPACE] Accept Value\x1B[K');
		console.log(leftEndChar + new Array(value + 1).join(spacer) + marker + 
					new Array(width - value + 1).join(spacer) + rightEndChar + value+'\x1B[K');
	}else if(showIntructions && showValue == false){
		console.log('< A   D >	[SPACE] Accept Value\x1B[K');
		console.log(leftEndChar + new Array(value + 1).join(spacer) + marker + 
					new Array(width - value + 1).join(spacer) + rightEndChar + '\x1B[K');
	}else if(showIntructions == false && showValue){
		console.log(leftEndChar + new Array(value + 1).join(spacer) + marker + 
					new Array(width - value + 1).join(spacer) + rightEndChar + value+'\x1B[K');
	}else{
		console.log(leftEndChar + new Array(value + 1).join(spacer) + marker + 
					new Array(width - value + 1).join(spacer) + rightEndChar + '\x1B[K');
	}
	
	while (true) {
		key = readlineSync.keyIn('', {
			hideEchoBack: true, 
			mask: '', 
			limit: 'ad '
		});
		//console.log('got "keypress"', key);
		if (key && key.ctrl && key.name == 'c') {
			process.stdin.pause();
		}

		if(key == 'a')
			value--;

		if(key == 'd')
			value++;

		if(key == ' ')
			break;

		if(value < 0)
			value = 0;

		if(value > width)
			value = width;

		if(showIntructions && showValue){
			console.log('\x1B['+(2)+'A< A   D >	[SPACE] Accept Value\x1B[K');
			console.log(leftEndChar + new Array(value + 1).join(spacer) + marker + 
						new Array(width - value + 1).join(spacer) + rightEndChar + value+'\x1B[K');
		}else if(showIntructions && showValue == false){
			console.log('\x1B['+(2)+'A< A   D >	[SPACE] Accept Value\x1B[K');
			console.log(leftEndChar + new Array(value + 1).join(spacer) + marker + 
						new Array(width - value + 1).join(spacer) + rightEndChar + '\x1B[K');
		}else if(showIntructions == false && showValue){
			console.log('\x1B['+(1)+'A' + leftEndChar + new Array(value + 1).join(spacer) + marker + 
						new Array(width - value + 1).join(spacer) + rightEndChar + value+'\x1B[K');
		}else{
			console.log('\x1B['+(1)+'A' + leftEndChar + new Array(value + 1).join(spacer) + marker + 
						new Array(width - value + 1).join(spacer) + rightEndChar + '\x1B[K');
		}
	}

	if(deleteOnCompletion){
		if(showIntructions && showValue){
			console.log('\x1B['+(2)+'A\x1B[K');
			console.log('\x1B[K');
		}else if(showIntructions && showValue == false){
			console.log('\x1B['+(2)+'A\x1B[K');
			console.log('\x1B[K');
		}else if(showIntructions == false && showValue){
			console.log('\x1B['+(1)+'A\x1B[K');
		}else{
			console.log('\x1B['+(1)+'A\x1B[K');
		}
	}

	return value;
}

ConInterface.getConsoleSelectionListInterfaceInput = function (marker, selectedMarker, startPosition, items, showIntructions, deleteOnCompletion) {
	var position = startPosition;

	if(showIntructions){
		console.log(' ^');
		console.log(' W');
		console.log('      	[SPACE] Accept Selection');
		console.log(' S');
		console.log(' v\n');
		for(var i in items)
			if(i == position)
				console.log(selectedMarker + items[i]);
			else
				console.log(marker + items[i]);
	}else{
		for(var i in items)
			if(i == position)
				console.log(selectedMarker + items[i]);
			else
				console.log(marker + items[i]);
	}
	
	while (true) {
		key = readlineSync.keyIn('', {
			hideEchoBack: true, 
			mask: '', 
			limit: 'ws '
		});
		//console.log('got "keypress"', key);
		if (key && key.ctrl && key.name == 'c') {
			process.stdin.pause();
		}

		if(key == 'w')
			position--;

		if(key == 's')
			position++;

		if(key == ' ')
			break;

		if(position < 0)
			position = 0;

		if(position >= items.length)
			position = items.length-1;

		if(showIntructions){
			console.log('\x1B['+(6+items.length)+'A ^\x1B[K');
			console.log(' W\x1B[K');
			console.log('      	[SPACE] Accept Selection\x1B[K');
			console.log(' S\x1B[K');
			console.log(' v\x1B[K\n');
			for(var i in items)
				if(i == position)
					console.log(selectedMarker + items[i] + '\x1B[K');
				else
					console.log(marker + items[i] + '\x1B[K');
		}else{
			for(var i in items)
				if(i == position)
					if(i == 0)
						console.log('\x1B['+(items.length)+'A'+selectedMarker + items[i] + '\x1B[K');
					else
						console.log(selectedMarker + items[i] + '\x1B[K');
				else
					if(i == 0)
						console.log('\x1B['+(items.length)+'A'+marker + items[i] + '\x1B[K');
					else
						console.log(marker + items[i] + '\x1B[K');
		}
	}

	if(deleteOnCompletion){
		if(showIntructions){
			console.log('\x1B['+(6+items.length)+'A\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K');
			console.log('\x1B[K\n\x1B[K');
			for(var i in items)
				console.log('\x1B[K');
			console.log('\x1B['+(6+items.length)+'A');
		}else{
			for(var i in items)
				if(i == 0)
					console.log('\x1B['+(items.length)+'A\x1B[K');
				else
					console.log('\x1B[K');
			console.log('\x1B['+(items.length)+'A');
		}
	}

	return position;
}